import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class ball here.
 * 
 * @author (joseph xu) 
 * @version (4/12)
 */
public class ball extends Actor
{
    private static final int MAXSIZE= 100;
    private int imageNumber;
    private int speed;
    /**
     * creat a ball and setrotation to where the mouse clicked
     */
    public ball(int direction) 

    {

        speed = Greenfoot.getRandomNumber(5) + 1;
        setImage();
        setRotation(direction);

    }

    
    /**
     * set an image with a random size and colored circle
     */
    private void setImage()
    {
        GreenfootImage img= new GreenfootImage(MAXSIZE,MAXSIZE);
        img.setColor(RandomColor());
        int size = Greenfoot.getRandomNumber(MAXSIZE);
        img.fillOval(0,0,size,size);
        setImage(img);
    }

    
    /**
     * create and return a random color
     */
    private Color RandomColor()
    {
        int r = Greenfoot.getRandomNumber(256);
        int g = Greenfoot.getRandomNumber(256);
        int b = Greenfoot.getRandomNumber(256);
        int alpha = Greenfoot.getRandomNumber(256);
        return new Color(r,g,b,alpha);

    }

    
    
    /**
     * Act - do whatever the ball wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        move(speed);

        if (atWorldEdge())
        {
            turn(151);

        }// Add your action code here.
        changeTransparency();
       
    } 

    void changeTransparency()
    {
        GreenfootImage img = getImage();
        int alpha = img.getTransparency();
        if(alpha>0){
            img.setTransparency(alpha-1);
        }
        else{
            getWorld().removeObject(this);
        }

    }

    public boolean atWorldEdge()
    {

        if(getX() < 10 || getX() > getWorld().getWidth() - 10)  
            return true;  
        if(getY() < 10 || getY() > getWorld().getHeight() - 10)  
            return true;  
        else 
            return false;  
    } // Add your action code here.
}    

